"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var http_1 = require('@angular/http');
var Observable_1 = require('rxjs/Observable');
require('rxjs/add/observable/throw');
require('rxjs/add/operator/catch');
require('rxjs/add/operator/do');
require('rxjs/add/operator/map');
require('rxjs/add/operator/switchMap');
require('rxjs/add/operator/toPromise');
var session_controller_1 = require('./session.controller');
var AuthHttp = (function () {
    function AuthHttp(http) {
        this.http = http;
    }
    AuthHttp.prototype.setHeaders = function (headers, request) {
        headers.forEach(function (header) {
            var key = Object.keys(header)[0];
            var headerValue = header[key];
            request.headers.set(key, headerValue);
        });
    };
    AuthHttp.prototype.setAuthHeaders = function (request) {
        if (session_controller_1.SessionController.userSignedIn()) {
            this.setHeaders(session_controller_1.SessionController.getAuthHeaders(), request);
        }
    };
    AuthHttp.prototype.checkAuthorization = function (response) {
        if (response.status === 401) {
            session_controller_1.SessionController.removeUser();
        }
        else {
            session_controller_1.SessionController.renewAccess(response.headers);
        }
    };
    AuthHttp.prototype.requestHelper = function (requestArgs, additionalOptions) {
        var options = new http_1.RequestOptions(requestArgs);
        if (additionalOptions) {
            options = options.merge(additionalOptions);
        }
        return this.request(new http_1.Request(options));
    };
    AuthHttp.prototype.request = function (url, options) {
        var _this = this;
        var request;
        var globalHeaders = session_controller_1.SessionController.config.globalHeaders;
        if (typeof url === 'string') {
            var reqOpts = options || {};
            if (!reqOpts.headers) {
                reqOpts.headers = new http_1.Headers();
            }
            if (globalHeaders) {
                this.setHeaders(globalHeaders, reqOpts);
            }
            this.setAuthHeaders(reqOpts);
            request = this.http.request(url, reqOpts);
        }
        else {
            var req = url;
            if (!req.headers) {
                req.headers = new http_1.Headers();
            }
            if (globalHeaders) {
                this.setHeaders(globalHeaders, req);
            }
            this.setAuthHeaders(req);
            request = this.http.request(req);
        }
        return request
            .do(function (response) {
            if (session_controller_1.SessionController.userSignedIn())
                _this.checkAuthorization(response);
        })
            .catch(function (error) {
            return Observable_1.Observable.throw(error.json() || 'Server error');
        });
    };
    AuthHttp.prototype.get = function (url, options) {
        return this.requestHelper({ url: url, method: http_1.RequestMethod.Get }, options);
    };
    AuthHttp.prototype.post = function (url, body, options) {
        return this.requestHelper({ url: url, body: body, method: http_1.RequestMethod.Post }, options);
    };
    AuthHttp.prototype.put = function (url, body, options) {
        return this.requestHelper({ url: url, body: body, method: http_1.RequestMethod.Put }, options);
    };
    AuthHttp.prototype.delete = function (url, options) {
        return this.requestHelper({ url: url, method: http_1.RequestMethod.Delete }, options);
    };
    AuthHttp.prototype.patch = function (url, body, options) {
        return this.requestHelper({ url: url, body: body, method: http_1.RequestMethod.Patch }, options);
    };
    AuthHttp.prototype.head = function (url, options) {
        return this.requestHelper({ url: url, method: http_1.RequestMethod.Head }, options);
    };
    AuthHttp = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [http_1.Http])
    ], AuthHttp);
    return AuthHttp;
}());
exports.AuthHttp = AuthHttp;
//# sourceMappingURL=auth.http.js.map