"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
require('rxjs/add/operator/do');
var auth_http_1 = require('./auth.http');
var session_controller_1 = require('./session.controller');
var AuthService = (function () {
    function AuthService(http, endpoint) {
        this.http = http;
        this.endpoint = endpoint;
    }
    AuthService.prototype.signUp = function (params) {
        return this.http.post(this.endpoint, JSON.stringify(params));
    };
    AuthService.prototype.signIn = function (params) {
        return this.http.post(this.endpoint + "/sign_in", JSON.stringify(params))
            .do(function (response) {
            session_controller_1.SessionController.setUser(response.headers);
        });
    };
    AuthService.prototype.signOut = function () {
        return this.http.delete(this.endpoint + "/sign_out")
            .do(function () {
            session_controller_1.SessionController.removeUser();
        });
    };
    AuthService.prototype.validateToken = function () {
        return this.http.get(this.endpoint + "/validate_token");
    };
    AuthService = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [auth_http_1.AuthHttp, String])
    ], AuthService);
    return AuthService;
}());
exports.AuthService = AuthService;
//# sourceMappingURL=auth.service.js.map